//
// Copyright 2003 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wDiffPane:
//   Displays output of diff or diff2


#ifndef p4wDiffPane_H
#define p4wDiffPane_H

#include "p4wPane.h"


class p4wDiffPane : public p4wPane {

public:

	p4wDiffPane( p4wView & ParentView, p4wRequest & Request, StrPtr *path, StrPtr *path2=0 );
	virtual	~p4wDiffPane();

	//
	// Render functions.
	
	virtual	void Begin();
	virtual	void RenderText( char *data );
    virtual void RenderBinary(char *data, int len);
	virtual void RenderInfo( char *data, char level );
	virtual	void End();

	void IncState() { fState++; };
	int GetState() { return fState; };

private:

	void Render2paneDiff( char * file );
	char *getNextLine(StrBuf &buf, char **ptr);
	char *toHTML(char *bgn);
	void nextdiff();
	void writeleft(char *str, int color, int star);
	void writeright(char *str, int color);
	void writesep();

	//
	// Any data returned?
	
	int fSeenData;

	//
	// Path(s) diffed
	
	StrPtr *fPath;
	StrPtr *fPath2;

	//
	// Type of Diff
	
	int		fType;

	//
	// StateMachine for Diff
	
	int		fState;

	//
	// Holds diff output

	StrBuf	fData;
	StrBuf	difbuf;

	//
	// Holds print file output

	StrBuf	fFile;
	StrBuf	in_buf;

	//
	// 2 pane diff variables

	char	action;
	char	prevaction;
	int		chunkCtr;
	int		totChunks;
	int		addChunks;
	int		delChunks;
	int		chgChunks;
	int		bCommaComma;
	int 	bStar;
	int 	cflag;
	int 	mflag;	// maximum line wrapping
	int 	nflag;	// no line wrapping
	int 	last;
	int 	bSep;
	int 	difctr;
	int 	in_ctr;
	int 	in2ctr;
	int		ctrdif;
	int		bSync;
	int		bEOF;
	int		lastWasStar;
	StrBuf	safe;

	// variable for heuristically detecting inconsistent line endings
	int		fSingletonCR;
	int		fGotLF;
};

#endif // p4wDiffPane_H
